<script setup lang="ts">
import { ref, reactive, watch } from "vue";
import { useQuasar } from "quasar";

import http from "@/plugins/http";
import config from "@/app.config";
import { useCounterMixin } from "@/stores/mixin";

import type {
  DataOption,
  FormPositionSelectDialog,
  OptionType,
  OptionLevel,
  OptionExecutive,
  FormPositionSelect,
} from "@/modules/01_metadata/interface/request/position/index";
import type { ResPosType } from "@/modules/01_metadata/interface/response/position/Main";

import DialogHeader from "@/components/DialogHeader.vue";

const $q = useQuasar();
const { dialogConfirm, showLoader, success, hideLoader, messageError } =
  useCounterMixin();

/**
 * props
 */
const modal = defineModel<boolean>("addPosition", { required: true });
const formData = defineModel<FormPositionSelect>("formData", {
  required: true,
});
const editCheck = defineModel<boolean>("editCheck", { required: true });
const copyCheck = defineModel<boolean>("copyCheck", { required: true });
const props = defineProps({
  getData: Function,
});

// ตัวเลือก
const executiveOpsMain = ref<DataOption[]>([]); //ตำแหน่งทางการบริหารหลัก
const executiveOps = ref<DataOption[]>([]); //ตำแหน่งทางการบริหาร
const typeOpsMain = ref<DataOption[]>([]); // ประเภทตำแหน่งหลัก
const typeOps = ref<DataOption[]>([]); // ประเภทตำแหน่ง
const levelOpsMain = ref<DataOption[]>([]); // ระดับตำแหน่งหลัก
const levelOps = ref<DataOption[]>([]); // ระดับตำแหน่ง

const isReadonly = ref<boolean>(false); // อ่านได้อย่างเดียว
const dataType = ref<ResPosType[]>([]); // ข้อมูลประเภทตำแหน่ง
// ฟอร์มข้อมูลตำแหน่ง
const formPositionSelect = reactive<FormPositionSelectDialog>({
  positionId: "",
  positionName: "", //ตำแหน่งในสายงาน
  positionField: "", //สายงาน
  positionType: "", //*ประเภทตำแหน่ง
  positionLevel: "", // ระดับตำแหน่ง
  positionExecutive: "", //ตำแหน่งทางการบริหาร
  positionExecutiveField: "", //ด้านทางการบริหาร
  positionArea: "", //ด้าน/สาขา
});
const isSpecial = ref<boolean>(false); // เฉพาะสายงานที่กำหนด

/**
 * เรียกรายการประเภทตำแหน่ง
 *
 * ฟังก์ชันนี้ดึงข้อมูลประเภทตำแหน่งจาก API และเซ็ตค่าให้กับตัวเลือกประเภทตำแหน่ง
 */
async function fetchType() {
  showLoader();
  await http
    .get(config.API.orgPosType)
    .then(async (res) => {
      const data = await res.data.result;
      dataType.value = data; // เก็บข้อมูลไว้ในตัวแปร dataType
      typeOpsMain.value = data.map((e: OptionType) => ({
        id: e.id,
        name: e.posTypeName,
      }));
      typeOps.value = typeOpsMain.value;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * เรียกรายการตำแหน่งทางการบริหาร
 *
 * ฟังก์ชันนี้ดึงข้อมูลตำแหน่งทางการบริหารจาก API และเซ็ตค่าให้กับตัวเลือกตำแหน่งทางการบริหาร
 */
async function fetchExecutive() {
  showLoader();
  await http
    .get(config.API.orgPosExecutive)
    .then(async (res) => {
      executiveOpsMain.value = await res.data.result.map(
        (e: OptionExecutive) => ({
          id: e.id,
          name: e.posExecutiveName,
        })
      );
      executiveOps.value = executiveOpsMain.value;
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
}

/**
 * บันทึกข้อมูลตำแหน่ง
 *
 * editCheck เป็น true จำทำการแก้ไขข้อมูล ถ้าไม่จะเป็นการ เพิ่มข้อมูล
 * บันทึกข้อมูลเสร็จ จะทำการโหลด ข้อมูลรายการตำแหน่งข้าราชการ ฯ ใหม่
 */
function onSubmit() {
  dialogConfirm($q, async () => {
    showLoader();
    const body = {
      posDictName: formPositionSelect.positionName,
      posDictField: formPositionSelect.positionField, //สายงาน
      posTypeId: formPositionSelect.positionType, //*ประเภทตำแหน่ง
      posLevelId: formPositionSelect.positionLevel, //*ระดับตำแหน่ง
      posExecutiveId: formPositionSelect.positionExecutive, //ตำแหน่งทางการบริหาร
      posDictExecutiveField: formPositionSelect.positionExecutiveField, //ด้านทางการบริหาร
      posDictArea: formPositionSelect.positionArea, //ด้าน/สาขา
      isSpecial: isSpecial.value,
    };

    // กำหนด path API
    const path = editCheck.value
      ? config.API.orgPosPositionById(formPositionSelect.positionId)
      : config.API.orgPosPosition;
    // กำหนด method
    const method = editCheck.value ? http.put : http.post;
    await method(path, body)
      .then(async () => {
        await props.getData?.();
        success($q, "บันทึกข้อมูลสำเร็จ");
        modal.value = false;
        editCheck.value = false;
        clearFormPositionSelect();
      })
      .catch((err) => {
        messageError($q, err);
      })
      .finally(() => {
        hideLoader();
      });
  });
}

/**
 * เคลียร์ข้อมูลในฟอร์มการเลือกตำแหน่ง
 *
 * รีเซ็ตค่าทุกฟิลด์ใน formPositionSelect ให้เป็นค่า default
 */
async function clearFormPositionSelect() {
  formPositionSelect.positionId = "";
  formPositionSelect.positionName = "";
  formPositionSelect.positionField = "";
  formPositionSelect.positionType = "";
  formPositionSelect.positionLevel = "";
  formPositionSelect.positionExecutive = "";
  formPositionSelect.positionExecutiveField = "";
  formPositionSelect.positionArea = "";
}

/**
 * อัปเดตตัวเลือกประเภทตำแหน่งและระดับตำแหน่งที่สอดคล้องกับประเภทที่เลือก
 * @param val id ของประเภทตำแหน่งที่เลือก
 */
async function updateSelectType(val: string) {
  // หาระดับตำแหน่งที่ตรงกับประเภทตำแหน่งที่เลือก
  const listLevel = dataType.value.find((e: ResPosType) => e.id === val);

  // ถ้าพบประเภทตำแหน่งที่ตรงกัน ให้กำหนดค่าตัวเลือกสำหรับระดับตำแหน่ง
  if (listLevel) {
    levelOpsMain.value = listLevel.posLevels.map((e: OptionLevel) => ({
      id: e.id,
      name: e.posLevelName,
    }));
    levelOps.value = levelOpsMain.value;
  }
}

/**
 * ปิด popup ฟอร์มข้อมูลตำแหน่ง
 *
 * และทำการเรียก function clearFormPositionSelect() เพื่อเคลียร์ข้อมูลในฟอร์มการเลือกตำแหน่ง
 */
function close() {
  modal.value = false;
  editCheck.value = false;
  copyCheck.value = false;
  clearFormPositionSelect();
}

/**
 * ส่งค่า css ออกไปตามเงื่อนไข
 *
 * @param val true/false
 */
function inputEdit(val: boolean) {
  return {
    "full-width cursor-pointer inputgreen ": val,
    "full-width cursor-pointer inputgreen": !val,
  };
}

/**
 * watch ค่าของ modal popup
 */
watch(
  () => modal.value,
  async () => {
    // ถ้า modal ถูกเปิดขึ้น
    if (modal.value == true) {
      // เรียกฟังก์ชัน fetchType และ fetchExecutive พร้อมกัน เพื่อดึงข้อมูลประเภทและข้อมูลตำแหน่งทางการบริหาร
      await Promise.all([fetchType(), fetchExecutive()]);

      // ถ้าอยู่ในโหมดแก้ไขหรือคัดลอกข้อมูล
      if (editCheck.value || copyCheck.value) {
        const dataList = formData.value; // ดึงข้อมูลที่ต้องการจาก formData

        // อัปเดตตัวเลือกประเภทตำแหน่งตามข้อมูลที่เลือก
        await updateSelectType(dataList.posTypeId);

        formPositionSelect.positionId = dataList.positionId;
        formPositionSelect.positionName = dataList.positionName;
        formPositionSelect.positionField = dataList.positionField;
        formPositionSelect.positionType = dataList.positionType;
        formPositionSelect.positionLevel = dataList.positionLevel;
        formPositionSelect.positionExecutive = dataList.positionExecutive;
        formPositionSelect.positionExecutiveField =
          dataList.positionExecutiveField;
        formPositionSelect.positionArea = dataList.positionArea;
        isSpecial.value = dataList.isSpecial;
      }
    }
  }
);
</script>

<template>
  <q-dialog v-model="modal" persistent>
    <q-card style="min-width: 50vw">
      <q-form greedy @submit.prevent="onSubmit">
        <DialogHeader
          :tittle="`${editCheck ? 'แก้ไขข้อมูลตำแหน่ง' : 'เพิ่มข้อมูลตำแหน่ง'}`"
          :close="close"
        />
        <q-separator />

        <q-card-section>
          <div class="row q-col-gutter-sm col-12">
            <div class="col-12">
              <q-input
                ref="positionNameRef"
                v-model="formPositionSelect.positionName"
                :class="inputEdit(isReadonly)"
                dense
                outlined
                for="#positionName"
                label="ตำแหน่งในสายงาน"
                lazy-rules
                hide-bottom-space
                :rules="[(val:string) => !!val || `${'กรุณากรอกตำแหน่งในสายงาน'}`]"
              />
            </div>
            <div class="col-6">
              <q-input
                ref="positionAreaRef"
                v-model="formPositionSelect.positionArea"
                :class="inputEdit(isReadonly)"
                dense
                outlined
                for="#positionArea"
                label="ด้าน/สาขา"
                lazy-rules
                hide-bottom-space
              />
            </div>
            <div class="col-6">
              <q-input
                ref="positionFieldRef"
                v-model="formPositionSelect.positionField"
                :class="inputEdit(isReadonly)"
                dense
                outlined
                for="#positionField"
                label="สายงาน"
                lazy-rules
                hide-bottom-space
                :rules="[(val:string) => !!val || `${'กรุณากรอกสายงาน'}`]"
              />
            </div>
            <div class="col-6">
              <q-select
                ref="positionTypeRef"
                :class="inputEdit(isReadonly)"
                label="ประเภทตำแหน่ง"
                v-model="formPositionSelect.positionType"
                :options="typeOps"
                emit-value
                dense
                @update:model-value="
                  updateSelectType(formPositionSelect.positionType),
                    (formPositionSelect.positionLevel = '')
                "
                map-options
                outlined
                option-label="name"
                option-value="id"
                lazy-rules
                hide-bottom-space
                :rules="[(val:string) => !!val || `${'กรุณาเลือกประเภทตำแหน่ง'}`]"
              />
            </div>
            <div class="col-6">
              <q-select
                ref="positionLevelRef"
                :class="inputEdit(isReadonly)"
                label="ระดับตำแหน่ง"
                v-model="formPositionSelect.positionLevel"
                :disable="formPositionSelect.positionType === ''"
                :options="levelOps"
                emit-value
                dense
                map-options
                outlined
                option-label="name"
                option-value="id"
                lazy-rules
                hide-bottom-space
                :rules="[(val:string) => !!val || `${'กรุณาเลือกระดับตำแหน่ง'}`]"
              />
            </div>
            <div class="col-6">
              <q-select
                ref="positionExecutiveRef"
                :class="inputEdit(isReadonly)"
                label="ตำแหน่งทางการบริหาร"
                v-model="formPositionSelect.positionExecutive"
                :options="executiveOps"
                emit-value
                dense
                map-options
                outlined
                option-label="name"
                option-value="id"
                lazy-rules
                hide-bottom-space
                clearable
              />
            </div>
            <div class="col-6">
              <q-input
                ref="positionExecutiveFieldRef"
                v-model="formPositionSelect.positionExecutiveField"
                :class="inputEdit(isReadonly)"
                dense
                outlined
                for="#positionExecutiveField"
                label="ด้านทางการบริหาร"
                lazy-rules
                hide-bottom-space
              />
            </div>

            <div class="col-6 self-center">
              <q-checkbox
                size="md"
                v-model="isSpecial"
                label="เฉพาะสายงานที่กำหนด"
              />
            </div>
          </div>
        </q-card-section>
        <q-separator />
        <q-card-actions align="right" class="bg-white text-teal">
          <q-btn type="submit" :label="`บันทึก`" color="public" />
        </q-card-actions>
      </q-form>
    </q-card>
  </q-dialog>
</template>
